local hcTk = HCToolkit
local aGUI = HCToolkit.AceGUI
local colors = HCToolkit.Constants.Colors

local WrapTextInColorCode = WrapTextInColorCode

local createPanelFns = {
    ["MaidenSoakBlacklist"] = hcTk.CreateMaidenPanel,
    ["AvatarMatrixSoaks"] = hcTk.CreateAvatarPanel
}

local treeC = nil

function hcTk.PanelInit()
    hcTk.OpenAssignments = false
end

function hcTk.AssignmentPanel()
  if (hcTk.OpenAssignments ~= true) then
    hcTk.OpenAssignments = true
    local f = aGUI:Create("Frame")
    f:SetTitle("HCToolkit Assignments")
    f:SetWidth(800)
    f:SetCallback("OnClose", function(widget) aGUI:Release(widget); hcTk.OpenAssignments = false; end)
    f:SetLayout("Fill")

    local t = aGUI:Create("TreeGroup")
    local list = hcTk.AssignmentOptions()
    t:SetTree(list)
    t:SetRelativeWidth(1)
    t:SetCallback("OnGroupSelected", hcTk.AssignmentSelectPanel)
    t:SetLayout("Flow")
    t:SelectByValue(list[1].value)
    treeC = t
    f:AddChild(treeC)
  end
end

function hcTk.AssignmentOptions()
    return {
        [1] = { text = "Maiden Soak Blacklist", value= "MaidenSoakBlacklist" },
        [2] = { text = "Avatar Matrix Soaks", value = "AvatarMatrixSoaks" }
    }
end

function hcTk.AssignmentSelectPanel(container, event, group)
    container:ReleaseChildren()
    createPanelFns[group](container)
end

function hcTk.AssignmentCreateHeader(container, text)
    local h = aGUI:Create("Label")
    h:SetText(WrapTextInColorCode(" " .. text, colors["gold"]))
    h:SetFontObject(GameFontHighlightLarge)
    h:SetFullWidth(true)
    container:AddChild(hcTk.AssignmentCreateLabel(" ", 1.0))
    container:AddChild(h)
end

function hcTk.AssignmentCreateLabel(text, width)
    local l = aGUI:Create("Label")
    l:SetText(text)
    l:SetRelativeWidth(width)
    return l
end

function hcTk.AssignmentCreateEditBox(defaultText, label, textChangeFn)
    local e = aGUI:Create("EditBox")
    e:DisableButton(true)
    e:SetCallback("OnTextChanged", textChangeFn)
    e:SetLabel(label)
    e:SetText(defaultText)
    return e
end