local hcTk = HCToolkit

function hcTk.ShareInformation()
    hcTk.SpecializationSend(UnitGUID("player"))
    hcTk.SpecializationRequest()
    hcTk.VersionSend(UnitGUID("player"))
    hcTk.VersionRequest()
end

function hcTk.StringRightPad(str, desiredLength, length)
    local spaces = desiredLength - length
    for i = 1, spaces, 1 do
        str = str .. " "
    end
    return str
end

function hcTk.MarkerIdToString(id)
    return string.format("|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_%d:0|t", id)
end

function hcTk.VersionPrint()
    if (hcTk.Group ~= nil and next(hcTk.Group) ~= nil) then
        for k, guid in ipairs(hcTk.GroupKeys) do
            hcTk:Print("#" .. k .. ": " .. hcTk.UnitPlayerString(hcTk.Group[guid]) .. " - " .. hcTk.Group[guid]["version"])
        end
    end
end

function hcTk.VersionRequest()
    local data = {
        ["type"] = "VersionRequest"
    }
    hcTk.DebugPrint("Requesting Version")

    hcTk:SendCommMessage("HCToolkit", hcTk:Serialize(data), "RAID")
end

function hcTk.VersionSend(guid)
    local data = {
        ["guid"] = guid,
        ["type"] = "VersionSend",
        ["version"] = hcTk.Constants.Version,
    }
    hcTk.DebugPrint("Sending Version " .. data["guid"] .. " | " .. data["version"])

    hcTk:SendCommMessage("HCToolkit", hcTk:Serialize(data), "RAID")
end